// dim.h
// Revision 13-oct-2003

#ifndef INCLUDE_DIM_H_
#define INCLUDE_DIM_H_

#include <iostream>
#include <cstddef>
#include <vector>

class Dimension {
	class Internal;
public:
	void add (size_t n) { dim.push_back (n); }
	size_t size () const { return dim.size (); }
	bool empty () const { return dim.empty (); }
	size_t elements () const;
	size_t operator [] (size_t n) const { return dim [n]; }
	size_t evalpos (const Dimension & d) const;
	bool operator == (const Dimension & d) const
	{ return dim == d.dim; }
private:
	std::vector <size_t> dim;
};

std::ostream & operator << (std::ostream & os, const Dimension & d);

#endif

// Fin de dim.h
